---------------------------------------------|
---Colorized BoostFlames and SneakerTrails---|
-------------By RetroStation#1909------------|
---------------------------------------------|

rawset(_G, "BoostFX", "V1") -- Heyo!
local S_BOOSTFLAME = S_BOOSTFLAME

--FUCKING PAIN
local bfx_colortable = {
	[0] = "Default",
	[1] = "White",
	[2] = "Silver",
	[3] = "Grey",
	[4] = "Nickel",
	[5] = "Black",
	[6] = "Skunk",
	[7] = "Fairy",
	[8] = "Popcorn",
	[9] = "Artichoke",
	[10] = "Pigeon",
	[11] = "Sepia",
	[12] = "Beige",
	[13] = "Walnut",
	[14] = "Brown",
	[15] = "Leather",
	[16] = "Salmon",
	[17] = "Pink",
	[18] = "Rose",
	[19] = "Brick",
	[20] = "Cinnamon",
	[21] = "Ruby",
	[22] = "Raspberry",
	[23] = "Cherry",
	[24] = "Red",
	[25] = "Crimson",
	[26] = "Maroon",
	[27] = "Lemonade",
	[28] = "Flame",
	[29] = "Scarlet",
	[30] = "Ketchup",
	[31] = "Dawn",
	[32] = "Sunset",
	[33] = "Creamsicle",
	[34] = "Orange",
	[35] = "Pumpkin",
	[36] = "Rosewood",
	[37] = "Burgundy",
	[38] = "Tangerine",
	[39] = "Peach",
	[40] = "Caramel",
	[41] = "Cream",
	[42] = "Gold",
	[43] = "Royal",
	[44] = "Bronze",
	[45] = "Copper",
	[46] = "Quarry",
	[47] = "Yellow",
	[48] = "Mustard",
	[49] = "Crocodile",
	[50] = "Olive",
	[51] = "Vomit",
	[52] = "Garden",
	[53] = "Lime",
	[54] = "Handheld",
	[55] = "Tea",
	[56] = "Pistachio",
	[57] = "Moss",
	[58] = "Camouflage",
	[59] = "RoboHood",
	[60] = "Mint",
	[61] = "Green",
	[62] = "Pinetree",
	[63] = "Emerald",
	[64] = "Swamp",
	[65] = "Dream",
	[66] = "Plague",
	[67] = "Algae",
	[68] = "Caribbean",
	[69] = "Azure",
	[70] = "Aqua",
	[71] = "Teal",
	[72] = "Cyan",
	[73] = "Jawz",
	[74] = "Cerulean",
	[75] = "Navy",
	[76] = "Platinum",
	[77] = "Slate",
	[78] = "Steel",
	[79] = "Thunder",
	[80] = "Rust",
	[81] = "Wristwatch",
	[82] = "Jet",
	[83] = "Sapphire",
	[84] = "Periwinkle",
	[85] = "Blue",
	[86] = "Blueberry",
	[87] = "Nova",
	[88] = "Pastel",
	[89] = "Moonslam",
	[90] = "Ultraviolet",
	[91] = "Dusk",
	[92] = "Bubblegum",
	[93] = "Purple",
	[94] = "Fuchsia",
	[95] = "Toxic",
	[96] = "Mauve",
	[97] = "Lavender",
	[98] = "Byzantium",
	[99] = "Pomegranate",
	[100] = "Lilac",
	[101] = "Player",
	[102] = "Inverted",
	[103] = "Trans",
	[104] = "Nonbinary",
	[105] = "Ace",
	[106] = "Bi",
	[107] = "Pan",
	[108] = "Polyam"
}

local bfx_cycles = {
	[103] = {SKINCOLOR_CYAN, SKINCOLOR_BUBBLEGUM, SKINCOLOR_WHITE},
	[104] = {SKINCOLOR_YELLOW, SKINCOLOR_WHITE, SKINCOLOR_BYZANTIUM, SKINCOLOR_BLACK},
	[105] = {SKINCOLOR_BLACK, SKINCOLOR_GREY, SKINCOLOR_WHITE, SKINCOLOR_PURPLE},
	[106] = {SKINCOLOR_PINK, SKINCOLOR_PURPLE, SKINCOLOR_BLUE},
	[107] = {SKINCOLOR_PINK, SKINCOLOR_YELLOW, SKINCOLOR_JAWZ},
	[108] = {SKINCOLOR_BLUE, SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_BLACK}
}

--Console command to set boostflame color, also affects Grow and Invicibility if a color cycle is chosen
COM_AddCommand("bfx_flamecolor", function (p, arg)
	local colornum = tonumber(arg)
	
	if not arg 
		if p.bfxflamecolor == 0
			CONS_Printf(p, "You are currently at default settings.")
		else
			CONS_Printf(p, "Your current Boost color is "..bfx_colortable[p.bfxflamecolor]..".")
		end
	else
		local colorset = 0
		for k,v in pairs(bfx_colortable)
			if not colorset
				if colornum == 0 and p.bfxflamecolor ~= 0
					p.bfxflamecolor = 0
					CONS_Printf(p, "Boost color succesfully reset.")
					colorset = 1
					S_StartSound(nil, sfx_chchng, p)
				elseif p.bfxflamecolor ~= 0
					if (arg:lower() == v:lower() or colornum == k) and (p.bfxflamecolor ~= colornum and (arg:lower() ~= bfx_colortable[p.bfxflamecolor]:lower()))
						p.bfxflamecolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Boost color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Boost color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				elseif p.bfxflamecolor == 0
					if (arg:lower() == v:lower() or colornum == k)
						p.bfxflamecolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Boost color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Boost color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				end
				//print("colorset: "..colorset)
			end
		end
		
		if not colorset
			if (colornum == 0 and p.bfxflamecolor == 0)
				CONS_Printf(p, "You are already at default settings.")
			elseif p.bfxflamecolor ~= 0
				if (p.bfxflamecolor == colornum  or arg:lower() == bfx_colortable[p.bfxflamecolor]:lower())
					CONS_Printf(p, "You have already set this color.")
				else
					CONS_Printf(p, "Please select a valid color.")
				end
			else
				CONS_Printf(p, "Please select a valid color.")
			end
			S_StartSound(nil, sfx_buzz3, p)
		end
		
	end
end)

--Sets Sneaker Trail color
COM_AddCommand("bfx_trailcolor", function (p, arg)
	local colornum = tonumber(arg)
	
	if not arg 
		if p.bfxtrailcolor == 0
			CONS_Printf(p, "You are currently at default settings.")
		else
			CONS_Printf(p, "Your current Trail color is "..bfx_colortable[p.bfxtrailcolor]..".")
		end
	else
		local colorset = 0
		for k,v in pairs(bfx_colortable)
			if not colorset
				if colornum == 0 and p.bfxtrailcolor ~= 0
					p.bfxtrailcolor = 0
					CONS_Printf(p, "Trail color succesfully reset.")
					colorset = 1
					S_StartSound(nil, sfx_chchng, p)
				elseif p.bfxtrailcolor ~= 0
					if (arg:lower() == v:lower() or colornum == k) and (p.bfxtrailcolor ~= colornum and (arg:lower() ~= bfx_colortable[p.bfxtrailcolor]:lower()))
						p.bfxtrailcolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Trail color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Trail color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				elseif p.bfxtrailcolor == 0
					if (arg:lower() == v:lower() or colornum == k)
						p.bfxtrailcolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Trail color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Trail color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				end
				//print("colorset: "..colorset)
			end
		end
		
		if not colorset
			if (colornum == 0 and p.bfxtrailcolor == 0)
				CONS_Printf(p, "You are already at default settings.")
			elseif p.bfxtrailcolor ~= 0
				if (p.bfxtrailcolor == colornum  or arg:lower() == bfx_colortable[p.bfxtrailcolor]:lower())
					CONS_Printf(p, "You have already set this color.")
				else
					CONS_Printf(p, "Please select a valid color.")
				end
			else
				CONS_Printf(p, "Please select a valid color.")
			end
			S_StartSound(nil, sfx_buzz3, p)
		end
		
	end
end)

--Sets MT_FASTLINE color
COM_AddCommand("bfx_linecolor", function (p, arg)
	local colornum = tonumber(arg)
	
	if not arg 
		if p.bfxlinecolor == 0
			CONS_Printf(p, "You are currently at default settings.")
		else
			CONS_Printf(p, "Your current Line color is "..bfx_colortable[p.bfxlinecolor]..".")
		end
	else
		local colorset = 0
		for k,v in pairs(bfx_colortable)
			if not colorset
				if colornum == 0 and p.bfxlinecolor ~= 0
					p.bfxlinecolor = 0
					CONS_Printf(p, "Color succesfully reset.")
					colorset = 1
					S_StartSound(nil, sfx_chchng, p)
				elseif p.bfxlinecolor ~= 0
					if (arg:lower() == v:lower() or colornum == k) and (p.bfxlinecolor ~= colornum and (arg:lower() ~= bfx_colortable[p.bfxlinecolor]:lower()))
						p.bfxlinecolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Line color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Line color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				elseif p.bfxlinecolor == 0
					if (arg:lower() == v:lower() or colornum == k)
						p.bfxlinecolor = k
						if (colornum == 49 or arg:lower() == "crocodile")
							CONS_Printf(p, "Your Line color has now been set to "..bfx_colortable[k]..", Awww Yeahhh.")
						elseif (colornum ~= 49 or arg:lower() ~= "crocodile")
							CONS_Printf(p, "Your Line color has now been set to "..bfx_colortable[k]..".")
						end
						colorset = 1
						S_StartSound(nil, sfx_chchng, p)
						//print("Current color: "..p.cbcolor)
					end
				end
				//print("colorset: "..colorset)
			end
		end
		
		if not colorset
			if (colornum == 0 and p.bfxlinecolor == 0)
				CONS_Printf(p, "You are already at default settings.")
			elseif p.bfxlinecolor ~= 0
				if (p.bfxlinecolor == colornum  or arg:lower() == bfx_colortable[p.bfxlinecolor]:lower())
					CONS_Printf(p, "You have already set this color.")
				else
					CONS_Printf(p, "Please select a valid color.")
				end
			else
				CONS_Printf(p, "Please select a valid color.")
			end
			S_StartSound(nil, sfx_buzz3, p)
		end
		
	end
end)

COM_AddCommand("bfx_info", function(p)
	if not p.bfxinit return end
	CONS_Printf(p, "Your current loadout is: ")
	if p.bfxflamecolor == 0
		CONS_Printf(p,"Boost color: Default")
	else
		CONS_Printf(p,"Boost color: "..bfx_colortable[p.bfxflamecolor])
	end
	if p.bfxtrailcolor == 0
		CONS_Printf(p,"Trail color: Default")
	else
		CONS_Printf(p,"Trail color: "..bfx_colortable[p.bfxtrailcolor])
	end
	if p.bfxlinecolor == 0
		CONS_Printf(p,"Line color: Default")
	else
		CONS_Printf(p,"Line color: "..bfx_colortable[p.bfxlinecolor])
	end
end)

local function bfx_init(p)
	p.bfxflamecolor = 0
	p.bfxtrailcolor = 0
	p.bfxlinecolor = 0
	p.flameshift = 1
	p.trailshift = 1
	p.lineshift = 1
	p.sparkleshift = 1
	p.invshift = 1
	p.bigshift = 1
	p.bfxpostracetimer = 0
end

local function bfx_refresh(p)
	if not p.bfxinit return end
	p.flameshift = 1
	p.trailshift = 1
	p.lineshift = 1
	p.sparkleshift = 1
	p.invshift = 1
	p.bigshift = 1
	p.bfxpostracetimer = 0
end
--Defining shift values separately because I'm fucking paranoid

local slipstacks

local function bfx_colorflame(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	if mo.state == S_BOOSTFLAME
		mo.colorized = true
		if mo.target.type == MT_ROCKETSNEAKER
			//print("Hooked to "..mo.target.target.player.name)
			//print("Zoomy shoes")
			slipstacks = (mo.target.target.player.stackedpanels or 0) + (mo.target.target.player.stackedsneakers or 0)
			if slipstacks < 2
				if mo.target.target and mo.target.target.player -- This is fucking cursed.
					if mo.target.target.player.bfxflamecolor == 101
						mo.color = mo.target.target.player.skincolor 
					elseif mo.target.target.player.bfxflamecolor == 102
						mo.color = ColorOpposite(mo.target.target.player.skincolor)
						//print("Opposite color: "..mo.color)
					elseif mo.target.target.player.bfxflamecolor >= 103			
						if leveltime%3 == 0
							mo.color = bfx_cycles[mo.target.target.player.bfxflamecolor][mo.target.target.player.flameshift]
							//print("Color: "..mo.color)
							if mo.target.target.player.flameshift == #bfx_cycles[mo.target.target.player.bfxflamecolor]
								mo.target.target.player.flameshift = 1
							else
								mo.target.target.player.flameshift = $ + 1
							end
						end
					elseif mo.target.target.player.bfxflamecolor ~= 0
						mo.color = mo.target.target.player.bfxflamecolor
					end
				end
			end
		elseif mo.target and mo.target.player
			slipstacks = (mo.target.player.stackedpanels or 0) + (mo.target.player.stackedsneakers or 0)
			if slipstacks < 2
				if mo.target.player.bfxflamecolor == 101
					mo.color = mo.target.player.skincolor
				elseif mo.target.player.bfxflamecolor == 102
					mo.color = ColorOpposite(mo.target.player.skincolor)
					//print("Opposite color: "..mo.color)
				elseif mo.target.player.bfxflamecolor >= 103
					if leveltime%3 == 0
						mo.color = bfx_cycles[mo.target.player.bfxflamecolor][mo.target.player.flameshift]
						//print("Color: "..mo.color)
						if mo.target.player.flameshift == #bfx_cycles[mo.target.player.bfxflamecolor]
							mo.target.player.flameshift = 1
						else
							mo.target.player.flameshift = $ + 1
						end
					end
				elseif mo.target.player.bfxflamecolor ~= 0
					mo.color = mo.target.player.bfxflamecolor
				end
			end
		end
	end
end
addHook("MobjThinker", bfx_colorflame, MT_BOOSTFLAME)

local function bfx_colortrail(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	if mo.target and mo.target.player
		if mo.target.player.bfxtrailcolor == 101
			mo.color = mo.target.player.skincolor
		elseif mo.target.player.bfxtrailcolor == 102
			mo.color = ColorOpposite(mo.target.player.skincolor)
		elseif mo.target.player.bfxtrailcolor >= 103
			if leveltime%3 == 0
				mo.color = bfx_cycles[mo.target.player.bfxtrailcolor][mo.target.player.trailshift]
				//print("Color: "..mo.color)
				if mo.target.player.trailshift == #bfx_cycles[mo.target.player.bfxtrailcolor]
					mo.target.player.trailshift = 1
				else
					mo.target.player.trailshift = $ + 1
				end
			end
		elseif mo.target.player.bfxtrailcolor ~= 0
			mo.color = mo.target.player.bfxtrailcolor
		end
		mo.colorized = true
	end
end
addHook("MobjThinker", bfx_colortrail, MT_SNEAKERTRAIL)

local function bfx_colorline(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	if mo.target and mo.target.player
		if mo.target.player.bfxlinecolor == 101
			mo.color = mo.target.player.skincolor
		elseif mo.target.player.bfxlinecolor == 102
			mo.color = ColorOpposite(mo.target.player.skincolor)
		elseif mo.target.player.bfxlinecolor >= 103
			if leveltime%3 == 0
				mo.color = bfx_cycles[mo.target.player.bfxlinecolor][mo.target.player.lineshift]
				//print("Color: "..mo.color)
				if mo.target.player.lineshift == #bfx_cycles[mo.target.player.bfxlinecolor]
					mo.target.player.lineshift = 1
				else
					mo.target.player.lineshift = $ + 1
				end
			end
		elseif mo.target.player.bfxlinecolor ~= 0
			mo.color = mo.target.player.bfxlinecolor
		end
		mo.colorized = true
	end
end
addHook("MobjThinker", bfx_colorline, MT_FASTLINE)


local function bfx_sparkletrail(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) return end
	if (mo.target.player.bfxflamecolor < 103) return end
	if mo.target and mo.target.player
		if mo.target.player.bfxflamecolor >= 103
			if leveltime%1 == 0
				mo.color = bfx_cycles[mo.target.player.bfxflamecolor][mo.target.player.sparkleshift]
				//print("Color: "..mo.color)
				if mo.target.player.sparkleshift == #bfx_cycles[mo.target.player.bfxflamecolor]
					mo.target.player.sparkleshift = 1
				else
					mo.target.player.sparkleshift = $ + 1
				end
			end
		end
		mo.colorized = true
	end
end
addHook("MobjThinker", bfx_sparkletrail, MT_SPARKLETRAIL)

local function bfx_invfx(p)
	if ((not p.bfxflamecolor) or (p.bfxflamecolor and p.bfxflamecolor < 103)) return end
	if p.kartstuff[k_invincibilitytimer] > 0
		local spooky = P_SpawnGhostMobj(p.mo)
		p.mo.colorized = true
		spooky.colorized = true
		if p.bfxflamecolor >= 103
			if leveltime%1 == 0
				p.mo.color = bfx_cycles[p.bfxflamecolor][p.invshift]
				spooky.color = bfx_cycles[p.bfxflamecolor][p.invshift]
				//print("Color: "..mo.color)
				if p.invshift == #bfx_cycles[p.bfxflamecolor]
					p.invshift = 1
				else
					p.invshift = $ + 1
				end
			end
		end
	else
		p.mo.color = p.skincolor
		p.mo.colorized = false
	end
end

local function GrowplusEndCheck(p)
	if p.huge == 1 
	or p.playerstate ~= PST_LIVE 
	or p.pflags & PF_TIMEOVER
	or (p.kartstuff[k_invincibilitytimer] == 0 and p.kartstuff[k_growshrinktimer] < 0) 
	or p.exiting then
	return true
	else return false end
end

local function bfx_bigfx(p)
	if not p.bfxflamecolor return end
	if (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.huge))
		if not p.kartstuff[k_invincibilitytimer]
			if p.bfxflamecolor >= 103
				p.mo.colorized = true
				if leveltime%3 == 0
					p.mo.color = bfx_cycles[p.bfxflamecolor][p.bigshift]
					//print("Color: "..mo.color)
					if p.bigshift == #bfx_cycles[p.bfxflamecolor]
						p.bigshift = 1
					else
						p.bigshift = $ + 1
					end
				end
			end
		end
	end
	if (HugeQuest and p.huge) and GrowplusEndCheck(p) then
		p.mo.colorized = false
		p.mo.color = p.skincolor
	end
end

addHook("MapLoad", function()
	for p in players.iterate
		bfx_refresh(p)
	end
end)

addHook("ThinkFrame", function()
	if leveltime < TICRATE return end
	for p in players.iterate
		if not p.bfxinit
			bfx_init(p)
			p.bfxinit = true
		end
		if not (p.mo and p.mo.valid) continue end
		bfx_invfx(p)
		bfx_bigfx(p)

		if p.exiting or (p.lives == 0)
			p.bfxpostracetimer = $ + 1
			if p.bfxpostracetimer == 2*TICRATE
				if not p.bfxtutorial -- Remind them of BFX commands; thanks Tyron
					chatprintf(p, "\x88*Use bfx_flamecolor, bfx_trailcolor, and bfx_linecolor to change your settings, and bfx_info to check your loadout. This message only displays once." , true)
					p.bfxtutorial = true
				end
				
			end
		end
	end
end)